

#include "main.h"
#include "mpu6050.h"
#include "inv_mpu.h"
#include "inv_mpu_dmp_motion_driver.h" 






void Print_yaw(float pitch,float roll,float yaw);
#define q30  1073741824.0f
#define PI    						(3.1415926f)

#define CENTRAL_DISPLAY_X			(90)	
#define CENTRAL_DISPLAY_Y			(38)	

uint8_t interrupt_flag = 0;

int lineid[]={1,2,2,3,3,4,4,1,5,6,6,7,7,8,8,5,8,4,7,3,6,2,5,1,1,3,2,4};//˳
	

	
	/**
 *\*\name   matconv.
 *\*\fun    Projection function:.
 *\*\param  none.
 *\*\return *a ,get the transformed value once.
**/
float *matconv(float *a, float b[3][3]){
    float res[3];
    int i;
    for(i=0; i<3; ++i)
        res[i] = b[i][0] * a[0] + b[i][1] * a[1] + b[i][2] * a[2];
    for(i=0; i<3; ++i)
        a[i] = res[i];
    return a;
}

/**
 *\*\name   rotate.
 *\*\fun    rotate function:Rotate points in solid space in the order z, y, x axes.
 *\*\param  none.
 *\*\return none.
**/
void rotate(float* obj, float x, float y, float z)
{
	float rz[3][3] = {0};
	float ry[3][3] = {0};
	float rx[3][3] = {0};
    x = (float)(x *1.0f * PI);
	y = (float)(y *1.0f * PI);
	z = (float)(z *1.0f * PI);
	
	//ֵrz
	rz[0][0] = cos(z); rz[0][1] = -sin(z); rz[0][2] = 0;
	rz[1][0] = sin(z); rz[1][1] = cos(z);  rz[1][2] = 0;
	rz[2][0] = 0;	   rz[2][1] = 0;       rz[2][2] = 1;
	
	//ֵry
	ry[0][0] = 1; 	   ry[0][1] =0;        ry[0][2] = 0;
	ry[1][0] = 0;      ry[1][1] = cos(y);  ry[1][2] = -sin(y);
	ry[2][0] = 0;	   ry[2][1] = sin(y);  ry[2][2] = cos(y);
	
	///ֵrx
	rx[0][0] = cos(x); rx[0][1] = 0;       rx[0][2] = sin(x);
	rx[1][0] = 0; 	   rx[1][1] = 1;  	   rx[1][2] = 0;
	rx[2][0] = -sin(x);rx[2][1] = 0;       rx[2][2] = cos(x);
	

    matconv(matconv(matconv(obj,rz), ry), rx);
}


void P_page1(void)
{
	float a=0,b,c;
			static uint8_t x0,y0,x1,y1,i= 0;
			static state=0;
	
			float cube[8][3]={{-15,-15,-15},{-15,15,-15},{15,15,-15},{15,-15,-15},{-15,-15,15},{-15,15,15},{15,15,15},{15,-15,15}};//
			//OLDEݣˢ
			OLED_Clear();
			
			
				
			
			//ô˺ֹ˸	
			OLED_ShowString(0,1,(const u8 *)" ",12);
			
			//ŷǲʾOled
			OLED_ShowString(0,1,(const u8 *)"pitch",12);
			OLED_ShowFloat(30,1,pitch,2,12);
			OLED_ShowString(0,15,(const u8 *)"roll",12);
			OLED_ShowFloat(23,15,roll,2,12);
			OLED_ShowString(0,25,(const u8 *)"yaw",12);
			OLED_ShowFloat(20,25,yaw,2,12);
		
		
	
				a=aacx/q30*100000;				
				b=aacy/q30*100000;
				
				c=aacz/q30*100000;
				
				if(a>1)
				{
					if(b>0.45)state=1;
					else if(b<-0.45)state=2;
					else if(c>0.45)state=3;
					else if(c<-0.45)state=4;
					else state=0;
			
				
				}
				OLED_ShowFloat(70,5,a,4,12);
				OLED_ShowFloat(70,15,b,4,12);
				OLED_ShowFloat(70,25,c,4,12);
			if(state==1)					
			OLED_ShowString(10,35,"L",12);
			else if(state==2)					
			OLED_ShowString(10,35,"R",12);
			else if(state==3)					
			OLED_ShowString(10,35,"D",12);
			else if(state==4)					
			OLED_ShowString(10,35,"U",12);
			else					
			OLED_ShowString(10,35," ",12);	
				
//			//yawoledתķ෴Ҫ
//			yaw = -yaw;
//			
//			//תȻӸ
//			for(i=0; i<8; i++)
//			   rotate(cube[i], roll/180, pitch/180, yaw/180);
//			for(i=0; i<28; i+=2)
//			{
//				x0 = CENTRAL_DISPLAY_X+cube[lineid[i]-1][0];
//				y0 = CENTRAL_DISPLAY_Y+cube[lineid[i]-1][1];
//				x1 = CENTRAL_DISPLAY_X+cube[lineid[i+1]-1][0];
//				y1 = CENTRAL_DISPLAY_Y+cube[lineid[i+1]-1][1];
//				OLED_DrawLine(x0, y0, x1, y1, 1);
//			}
			//OLDEݲˢ
			OLED_Refresh_Gram();		
		}

