/*****************************************************************************
 * Copyright (c) 2019, Nations Technologies Inc.
 *
 * All rights reserved.
 * ****************************************************************************
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the disclaimer below.
 *
 * Nations' name may not be used to endorse or promote products derived from
 * this software without specific prior written permission.
 *
 * DISCLAIMER: THIS SOFTWARE IS PROVIDED BY NATIONS "AS IS" AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * DISCLAIMED. IN NO EVENT SHALL NATIONS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ****************************************************************************/

/**
*\*\file main.c
*\*\author Nations
*\*\version v1.0.0
*\*\copyright Copyright (c) 2019, Nations Technologies Inc. All rights reserved.
**/

#include "main.h"
#include "log.h"
#include "i2c_drv.h"
#include "oled.h"
#include "mpu6050.h"
#include "bsp_delay.h"
#include "mpu6050.h"
#include "math.h"
#include "inv_mpu.h"
#include "inv_mpu_dmp_motion_driver.h" 
#include "oled.h"
#include "log.h"

#include "Key_Menu.h"



short aacx,aacy,aacz;					//ٶȴԭʼ
short gyrox,gyroy,gyroz;				//ԭʼ	
float pitch = 0.0,roll = 0.0,yaw =0.0; 	//ŷ
void get_ADU(void);



/**
 *\*\name   main.
 *\*\fun    main function.
 *\*\param  none.
 *\*\return none.
**/
int main(void)
{
	
	log_init();
	key_init();
	i2c_master_init();
	oled_init();
	
	OLED_tp(0,0);
	OLED_Refresh_Gram();
	MPU_Init();								//ʼMPU6050

	while(mpu_dmp_init());					//ȴMPUʼ
			
	while(1)
	{
		
		
	
		get_ADU();
		Key_Meun();

	}
}


void get_ADU(void)
{
		pitch = 0.0,roll = 0.0,yaw =0.0;
		//ȡǰĺ
			while(mpu_dmp_get_data(&pitch,&roll,&yaw)!=0)
			{
				MPU_Get_Accelerometer(&aacx,&aacy,&aacz);	//õٶȴ
			}
			MPU_Get_Gyroscope(&gyrox,&gyroy,&gyroz);	//õ
		
}